for Minecraft 1.14+

for Minecraft 1.8.x - 1.12.x